diff --git a/contrib/ntp/sntp/scm-rev b/contrib/ntp/sntp/scm-rev
index 5e3d42f5e853..3e354b6addff 100644
--- a/contrib/ntp/sntp/scm-rev
+++ b/contrib/ntp/sntp/scm-rev
@@ -1 +1 @@
-1.4004
+1.4062
diff --git a/contrib/ntp/sntp/scripts/cvo.sh b/contrib/ntp/sntp/scripts/cvo.sh
index ecd80922301f..77a161172499 100755
--- a/contrib/ntp/sntp/scripts/cvo.sh
+++ b/contrib/ntp/sntp/scripts/cvo.sh
@@ -26,7 +26,13 @@ case "$#" in
     CVO_OS=$4
     case "$cvo_KERN" in
      linux)			# Braindamage.  We want OS, not kernel info
-	if lsb_release > /dev/null 2>&1
+	if test -f /etc/os-release
+	then
+	    . /etc/os-release
+	    ID=`echo $ID | tr '-' '_'`
+	    CVO_OS="${ID}${VERSION_ID}"
+	    CVO_KOSVER=`uname -r`
+	elif lsb_release > /dev/null 2>&1
 	then
 	    CVO_OS=`lsb_release --id --short | tr '[:upper:]' '[:lower:]'`
 	    CVO_OS="$CVO_OS`lsb_release --release --short`"
diff --git a/contrib/ntp/sntp/sntp-opts.c b/contrib/ntp/sntp/sntp-opts.c
index 29c726cb5973..d4634aa8d710 100644
--- a/contrib/ntp/sntp/sntp-opts.c
+++ b/contrib/ntp/sntp/sntp-opts.c
@@ -1,7 +1,7 @@
 /*
  *  EDIT THIS FILE WITH CAUTION  (sntp-opts.c)
  *
- *  It has been AutoGen-ed  June  6, 2023 at 04:35:52 AM by AutoGen 5.18.16
+ *  It has been AutoGen-ed  May 25, 2024 at 12:02:07 AM by AutoGen 5.18.16
  *  From the definitions    sntp-opts.def
  *  and the template file   options
  *
@@ -18,7 +18,7 @@
  * The sntp program is copyrighted and licensed
  * under the following terms:
  *
- *  Copyright (C) 1992-2023 The University of Delaware and Network Time Foundation, all rights reserved.
+ *  Copyright (C) 1992-2024 The University of Delaware and Network Time Foundation, all rights reserved.
  *  This is free software. It is licensed for use, modification and
  *  redistribution under the terms of the NTP License, copies of which
  *  can be seen at:
@@ -74,8 +74,8 @@ extern FILE * option_usage_fp;
  *  static const strings for sntp options
  */
 static char const sntp_opt_strs[2567] =
-/*     0 */ "sntp 4.2.8p17\n"
-            "Copyright (C) 1992-2023 The University of Delaware and Network Time Foundation, all rights reserved.\n"
+/*     0 */ "sntp 4.2.8p18\n"
+            "Copyright (C) 1992-2024 The University of Delaware and Network Time Foundation, all rights reserved.\n"
             "This is free software. It is licensed for use, modification and\n"
             "redistribution under the terms of the NTP License, copies of which\n"
             "can be seen at:\n"
@@ -160,7 +160,7 @@ static char const sntp_opt_strs[2567] =
 /*  2313 */ "LOAD_OPTS\0"
 /*  2323 */ "no-load-opts\0"
 /*  2336 */ "SNTP\0"
-/*  2341 */ "sntp - standard Simple Network Time Protocol client program - Ver. 4.2.8p17\n"
+/*  2341 */ "sntp - standard Simple Network Time Protocol client program - Ver. 4.2.8p18\n"
             "Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]... \\\n"
             "\t\t[ hostname-or-IP ...]\n\0"
 /*  2501 */ "$HOME\0"
@@ -168,7 +168,7 @@ static char const sntp_opt_strs[2567] =
 /*  2509 */ ".ntprc\0"
 /*  2516 */ "https://bugs.ntp.org, bugs@ntp.org\0"
 /*  2551 */ "\n\0"
-/*  2553 */ "sntp 4.2.8p17";
+/*  2553 */ "sntp 4.2.8p18";
 
 /**
  *  ipv4 option description with
@@ -1180,8 +1180,8 @@ static void bogus_function(void) {
      translate option names.
    */
   /* referenced via sntpOptions.pzCopyright */
-  puts(_("sntp 4.2.8p17\n\
-Copyright (C) 1992-2023 The University of Delaware and Network Time Foundation, all rights reserved.\n\
+  puts(_("sntp 4.2.8p18\n\
+Copyright (C) 1992-2024 The University of Delaware and Network Time Foundation, all rights reserved.\n\
 This is free software. It is licensed for use, modification and\n\
 redistribution under the terms of the NTP License, copies of which\n\
 can be seen at:\n"));
@@ -1270,7 +1270,7 @@ implied warranty.\n"));
   puts(_("load options from a config file"));
 
   /* referenced via sntpOptions.pzUsageTitle */
-  puts(_("sntp - standard Simple Network Time Protocol client program - Ver. 4.2.8p17\n\
+  puts(_("sntp - standard Simple Network Time Protocol client program - Ver. 4.2.8p18\n\
 Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]... \\\n\
 \t\t[ hostname-or-IP ...]\n"));
 
@@ -1278,7 +1278,7 @@ Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]... \\\n\
   puts(_("\n"));
 
   /* referenced via sntpOptions.pzFullVersion */
-  puts(_("sntp 4.2.8p17"));
+  puts(_("sntp 4.2.8p18"));
 
   /* referenced via sntpOptions.pzFullUsage */
   puts(_("<<<NOT-FOUND>>>"));
diff --git a/contrib/ntp/sntp/sntp-opts.h b/contrib/ntp/sntp/sntp-opts.h
index a7cff4d550b0..e9efb0c4da62 100644
--- a/contrib/ntp/sntp/sntp-opts.h
+++ b/contrib/ntp/sntp/sntp-opts.h
@@ -1,7 +1,7 @@
 /*
  *  EDIT THIS FILE WITH CAUTION  (sntp-opts.h)
  *
- *  It has been AutoGen-ed  June  6, 2023 at 04:35:52 AM by AutoGen 5.18.16
+ *  It has been AutoGen-ed  May 25, 2024 at 12:02:07 AM by AutoGen 5.18.16
  *  From the definitions    sntp-opts.def
  *  and the template file   options
  *
@@ -18,7 +18,7 @@
  * The sntp program is copyrighted and licensed
  * under the following terms:
  *
- *  Copyright (C) 1992-2023 The University of Delaware and Network Time Foundation, all rights reserved.
+ *  Copyright (C) 1992-2024 The University of Delaware and Network Time Foundation, all rights reserved.
  *  This is free software. It is licensed for use, modification and
  *  redistribution under the terms of the NTP License, copies of which
  *  can be seen at:
@@ -99,9 +99,9 @@ typedef enum {
 /** count of all options for sntp */
 #define OPTION_CT    23
 /** sntp version */
-#define SNTP_VERSION       "4.2.8p17"
+#define SNTP_VERSION       "4.2.8p18"
 /** Full sntp version text */
-#define SNTP_FULL_VERSION  "sntp 4.2.8p17"
+#define SNTP_FULL_VERSION  "sntp 4.2.8p18"
 
 /**
  *  Interface defines for all options.  Replace "n" with the UPPER_CASED
diff --git a/contrib/ntp/sntp/sntp.1sntpman b/contrib/ntp/sntp/sntp.1sntpman
index 7d532020c280..d10d13cddbbc 100644
--- a/contrib/ntp/sntp/sntp.1sntpman
+++ b/contrib/ntp/sntp/sntp.1sntpman
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH sntp 1sntpman "06 Jun 2023" "4.2.8p17" "User Commands"
+.TH sntp 1sntpman "25 May 2024" "4.2.8p18" "User Commands"
 .\"
 .\" EDIT THIS FILE WITH CAUTION (in-mem file)
 .\"
-.\" It has been AutoGen-ed June 6, 2023 at 04:36:14 AM by AutoGen 5.18.16
+.\" It has been AutoGen-ed May 25, 2024 at 12:02:30 AM by AutoGen 5.18.16
 .\" From the definitions sntp-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
@@ -353,7 +353,7 @@ it to autogen-users@lists.sourceforge.net.  Thank you.
 .NOP  "Dave Hart" 
 .br
 .SH "COPYRIGHT"
-Copyright (C) 1992-2023 The University of Delaware and Network Time Foundation all rights reserved.
+Copyright (C) 1992-2024 The University of Delaware and Network Time Foundation all rights reserved.
 This program is released under the terms of the NTP license, <http://ntp.org/license>.
 .SH "BUGS"
 Please send bug reports to: https://bugs.ntp.org, bugs@ntp.org
diff --git a/contrib/ntp/sntp/sntp.1sntpmdoc b/contrib/ntp/sntp/sntp.1sntpmdoc
index 0f58ff4090af..f0b3f4641ea1 100644
--- a/contrib/ntp/sntp/sntp.1sntpmdoc
+++ b/contrib/ntp/sntp/sntp.1sntpmdoc
@@ -1,9 +1,9 @@
-.Dd June 6 2023
+.Dd May 25 2024
 .Dt SNTP 1sntpmdoc User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (sntp-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  June  6, 2023 at 04:36:10 AM by AutoGen 5.18.16
+.\"  It has been AutoGen-ed  May 25, 2024 at 12:02:26 AM by AutoGen 5.18.16
 .\"  From the definitions    sntp-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
@@ -308,7 +308,7 @@ it to autogen\-users@lists.sourceforge.net.  Thank you.
 .An "Harlan Stenn"
 .An "Dave Hart"
 .Sh "COPYRIGHT"
-Copyright (C) 1992\-2023 The University of Delaware and Network Time Foundation all rights reserved.
+Copyright (C) 1992\-2024 The University of Delaware and Network Time Foundation all rights reserved.
 This program is released under the terms of the NTP license, <http://ntp.org/license>.
 .Sh "BUGS"
 Please send bug reports to: https://bugs.ntp.org, bugs@ntp.org
diff --git a/contrib/ntp/sntp/sntp.man.in b/contrib/ntp/sntp/sntp.man.in
index ca4ddea8e35c..050d1e9cd3f0 100644
--- a/contrib/ntp/sntp/sntp.man.in
+++ b/contrib/ntp/sntp/sntp.man.in
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH sntp @SNTP_MS@ "06 Jun 2023" "4.2.8p17" "User Commands"
+.TH sntp @SNTP_MS@ "25 May 2024" "4.2.8p18" "User Commands"
 .\"
 .\" EDIT THIS FILE WITH CAUTION (in-mem file)
 .\"
-.\" It has been AutoGen-ed June 6, 2023 at 04:36:14 AM by AutoGen 5.18.16
+.\" It has been AutoGen-ed May 25, 2024 at 12:02:30 AM by AutoGen 5.18.16
 .\" From the definitions sntp-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
@@ -353,7 +353,7 @@ it to autogen-users@lists.sourceforge.net.  Thank you.
 .NOP  "Dave Hart" 
 .br
 .SH "COPYRIGHT"
-Copyright (C) 1992-2023 The University of Delaware and Network Time Foundation all rights reserved.
+Copyright (C) 1992-2024 The University of Delaware and Network Time Foundation all rights reserved.
 This program is released under the terms of the NTP license, <http://ntp.org/license>.
 .SH "BUGS"
 Please send bug reports to: https://bugs.ntp.org, bugs@ntp.org
diff --git a/contrib/ntp/sntp/sntp.mdoc.in b/contrib/ntp/sntp/sntp.mdoc.in
index 3e5fa337725f..2a3f8cfaa9c9 100644
--- a/contrib/ntp/sntp/sntp.mdoc.in
+++ b/contrib/ntp/sntp/sntp.mdoc.in
@@ -1,9 +1,9 @@
-.Dd June 6 2023
+.Dd May 25 2024
 .Dt SNTP @SNTP_MS@ User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (sntp-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  June  6, 2023 at 04:36:10 AM by AutoGen 5.18.16
+.\"  It has been AutoGen-ed  May 25, 2024 at 12:02:26 AM by AutoGen 5.18.16
 .\"  From the definitions    sntp-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
@@ -308,7 +308,7 @@ it to autogen\-users@lists.sourceforge.net.  Thank you.
 .An "Harlan Stenn"
 .An "Dave Hart"
 .Sh "COPYRIGHT"
-Copyright (C) 1992\-2023 The University of Delaware and Network Time Foundation all rights reserved.
+Copyright (C) 1992\-2024 The University of Delaware and Network Time Foundation all rights reserved.
 This program is released under the terms of the NTP license, <http://ntp.org/license>.
 .Sh "BUGS"
 Please send bug reports to: https://bugs.ntp.org, bugs@ntp.org
diff --git a/contrib/ntp/sntp/tests/crypto.c b/contrib/ntp/sntp/tests/crypto.c
index 8ecd74368011..509efe79c3a2 100644
--- a/contrib/ntp/sntp/tests/crypto.c
+++ b/contrib/ntp/sntp/tests/crypto.c
@@ -7,15 +7,14 @@
 
 #define CMAC "AES128CMAC"
 
-#define MD5_LENGTH 16
 #define SHA1_LENGTH 20
 #define CMAC_LENGTH 16
 
 
-void test_MakeMd5Mac(void);
+void test_MakeSHAKE128Mac(void);
 void test_MakeSHA1Mac(void);
 void test_MakeCMac(void);
-void test_VerifyCorrectMD5(void);
+void test_VerifySHAKE128(void);
 void test_VerifySHA1(void);
 void test_VerifyCMAC(void);
 void test_VerifyFailure(void);
@@ -26,26 +25,36 @@ void VerifyOpenSSLCMAC(struct key *cmac);
 
 
 void
-test_MakeMd5Mac(void)
+test_MakeSHAKE128Mac(void)
 {
-	const char* PKT_DATA = "abcdefgh0123";
-	const int PKT_LEN = strlen(PKT_DATA);
-	const char* EXPECTED_DIGEST =
-		"\x52\x6c\xb8\x38\xaf\x06\x5a\xfb\x6c\x98\xbb\xc0\x9b\x0a\x7a\x1b";
-	char actual[MD5_LENGTH];
-
-	struct key md5;
-	md5.next = NULL;
-	md5.key_id = 10;
-	md5.key_len = 6;
-	memcpy(&md5.key_seq, "md5seq", md5.key_len);
-	strlcpy(md5.typen, "MD5", sizeof(md5.typen));
-	md5.typei = keytype_from_text(md5.typen, NULL);
-	
-	TEST_ASSERT_EQUAL(MD5_LENGTH,
-			  make_mac(PKT_DATA, PKT_LEN, MD5_LENGTH, &md5, actual));
-
-	TEST_ASSERT_TRUE(memcmp(EXPECTED_DIGEST, actual, MD5_LENGTH) == 0);
+#ifdef OPENSSL
+
+	const char KEY[] = "SHAKE128 unit test key";
+	const u_char PAYLOAD[] = "packettestdata16";
+	const size_t PAYLOAD_LEN = sizeof(PAYLOAD) - 1;
+	const u_char EXPECTED_DIGEST[] =
+		"\x62\x5A\x8F\xE4\x66\xCB\xF3\xA6"
+		"\x73\x62\x68\x8D\x11\xB8\x42\xBB";
+	u_char actual[sizeof(EXPECTED_DIGEST) - 1];
+	struct key sk;
+
+	sk.next = NULL;
+	sk.key_id = 10;
+	sk.key_len = sizeof(KEY) - 1;
+	memcpy(&sk.key_seq, KEY, min(sizeof(sk.key_seq), sk.key_len));
+	strlcpy(sk.typen, "SHAKE128", sizeof(sk.typen));
+	sk.typei = keytype_from_text(sk.typen, NULL);
+
+	TEST_ASSERT_EQUAL(sizeof(actual),
+			  make_mac(PAYLOAD, PAYLOAD_LEN, &sk, actual,
+				   sizeof(actual)));
+
+	TEST_ASSERT_EQUAL_HEX8_ARRAY(EXPECTED_DIGEST, actual, sizeof(actual));
+#else
+
+	TEST_IGNORE_MESSAGE("OpenSSL not found, skipping...");
+
+#endif	/* OPENSSL */
 }
 
 
@@ -70,14 +79,15 @@ test_MakeSHA1Mac(void)
 	sha1.typei = keytype_from_text(sha1.typen, NULL);
 
 	TEST_ASSERT_EQUAL(SHA1_LENGTH,
-			  make_mac(PKT_DATA, PKT_LEN, SHA1_LENGTH, &sha1, actual));
+			  make_mac(PKT_DATA, PKT_LEN, &sha1, actual,
+				   SHA1_LENGTH));
 
 	TEST_ASSERT_EQUAL_MEMORY(EXPECTED_DIGEST, actual, SHA1_LENGTH);
-	
+
 #else
-	
+
 	TEST_IGNORE_MESSAGE("OpenSSL not found, skipping...");
-	
+
 #endif	/* OPENSSL */
 }
 
@@ -93,8 +103,8 @@ test_MakeCMac(void)
 		"\xdd\x35\xd5\xf5\x14\x23\xd9\xd6"
 		"\x38\x5d\x29\x80\xfe\x51\xb9\x6b";
 	char actual[CMAC_LENGTH];
-
 	struct key cmac;
+
 	cmac.next = NULL;
 	cmac.key_id = 30;
 	cmac.key_len = CMAC_LENGTH;
@@ -102,37 +112,53 @@ test_MakeCMac(void)
 	memcpy(&cmac.typen, CMAC, strlen(CMAC) + 1);
 
 	TEST_ASSERT_EQUAL(CMAC_LENGTH,
-		    make_mac(PKT_DATA, PKT_LEN, CMAC_LENGTH, &cmac, actual));
+		    make_mac(PKT_DATA, PKT_LEN, &cmac, actual, CMAC_LENGTH));
 
 	TEST_ASSERT_EQUAL_MEMORY(EXPECTED_DIGEST, actual, CMAC_LENGTH);
-	
+
 #else
-	
-	TEST_IGNORE_MESSAGE("OpenSSL not found, skipping...");
-	
+
+	TEST_IGNORE_MESSAGE("CMAC not enabled, skipping...");
+
 #endif	/* OPENSSL */
 }
 
 
 void
-test_VerifyCorrectMD5(void)
+test_VerifySHAKE128(void)
 {
-	const char* PKT_DATA =
-	    "sometestdata"			/* Data */
-	    "\0\0\0\0"				/* Key-ID (unused) */
-	    "\xc7\x58\x99\xdd\x99\x32\x0f\x71"	/* MAC */
-	    "\x2b\x7b\xfe\x4f\xa2\x32\xcf\xac";
-	const int PKT_LEN = 12;
+#ifdef OPENSSL
+	const char KEY[] = "SHAKE128 unit test key";
+	const u_char PAYLOAD[] = "packettestdata16";
+	const size_t PAYLOAD_LEN = sizeof(PAYLOAD) - 1;
+	const u_char EXPECTED_DIGEST[] =
+		"\x62\x5A\x8F\xE4\x66\xCB\xF3\xA6"
+		"\x73\x62\x68\x8D\x11\xB8\x42\xBB";
+	const size_t DIGEST_LEN = sizeof(EXPECTED_DIGEST) - 1;
+	struct key sk;
+	u_char PKT_DATA[  PAYLOAD_LEN + sizeof(sk.key_id)
+			+ DIGEST_LEN];
+	u_char *p;
+
+	sk.next = NULL;
+	sk.key_id = 0;
+	sk.key_len = sizeof(KEY) - 1;
+	memcpy(&sk.key_seq, KEY, min(sizeof(sk.key_seq), sk.key_len));
+	strlcpy(sk.typen, "SHAKE128", sizeof(sk.typen));
+	sk.typei = keytype_from_text(sk.typen, NULL);
+
+	p = PKT_DATA;
+	memcpy(p, PAYLOAD, PAYLOAD_LEN);	  p += PAYLOAD_LEN;
+	memcpy(p, &sk.key_id, sizeof(sk.key_id)); p += sizeof(sk.key_id);
+	memcpy(p, EXPECTED_DIGEST, DIGEST_LEN);	  p += DIGEST_LEN;
+	TEST_ASSERT_TRUE(sizeof(PKT_DATA) == p - PKT_DATA);
+
+	TEST_ASSERT_TRUE(auth_md5(PKT_DATA, PAYLOAD_LEN, DIGEST_LEN, &sk));
+#else
 
-	struct key md5;
-	md5.next = NULL;
-	md5.key_id = 0;
-	md5.key_len = 6;
-	memcpy(&md5.key_seq, "md5key", md5.key_len);
-	strlcpy(md5.typen, "MD5", sizeof(md5.typen));
-	md5.typei = keytype_from_text(md5.typen, NULL);
+	TEST_IGNORE_MESSAGE("OpenSSL not found, skipping...");
 
-	TEST_ASSERT_TRUE(auth_md5(PKT_DATA, PKT_LEN, MD5_LENGTH, &md5));
+#endif	/* OPENSSL */
 }
 
 
@@ -147,21 +173,21 @@ test_VerifySHA1(void)
 	    "\xad\x07\xde\x36\x39\xa6\x77\xfa\x5b\xce"	/* MAC */
 	    "\x2d\x8a\x7d\x06\x96\xe6\x0c\xbc\xed\xe1";
 	const int PKT_LEN = 12;
-
 	struct key sha1;
+
 	sha1.next = NULL;
 	sha1.key_id = 0;
 	sha1.key_len = 7;
 	memcpy(&sha1.key_seq, "sha1key", sha1.key_len);
-	strlcpy(sha1.typen, "SHA1", sizeof(sha1.typen));	
+	strlcpy(sha1.typen, "SHA1", sizeof(sha1.typen));
 	sha1.typei = keytype_from_text(sha1.typen, NULL);
 
 	TEST_ASSERT_TRUE(auth_md5(PKT_DATA, PKT_LEN, SHA1_LENGTH, &sha1));
-	
+
 #else
-	
+
 	TEST_IGNORE_MESSAGE("OpenSSL not found, skipping...");
-	
+
 #endif	/* OPENSSL */
 }
 
@@ -169,12 +195,6 @@ test_VerifySHA1(void)
 void
 test_VerifyCMAC(void)
 {
-	const char* PKT_DATA =
-	    "sometestdata"				/* Data */
-	    "\0\0\0\0"					/* Key-ID (unused) */
-	    "\x4e\x0c\xf0\xe2\xc7\x8e\xbb\xbf"		/* MAC */
-	    "\x79\xfc\x87\xc7\x8b\xb7\x4a\x0b";
-	const int PKT_LEN = 12;
 	struct key cmac;
 
 	cmac.next = NULL;
@@ -198,9 +218,9 @@ VerifyOpenSSLCMAC(struct key *cmac)
 	TEST_IGNORE_MESSAGE("VerifyOpenSSLCMAC needs to be implemented, skipping...");
 
 #else
-	
-	TEST_IGNORE_MESSAGE("OpenSSL not found, skipping...");
-	
+
+	TEST_IGNORE_MESSAGE("CMAC not enabled, skipping...");
+
 #endif	/* OPENSSL */
 	return;
 }
@@ -222,42 +242,77 @@ VerifyLocalCMAC(struct key *cmac)
 void
 test_VerifyFailure(void)
 {
-	/* We use a copy of the MD5 verification code, but modify the
-	 * last bit to make sure verification fails.
+	/*
+	 * We use a copy of test_VerifySHAKE128(), but modify the
+	 * last packet octet to make sure verification fails.
 	 */
-	const char* PKT_DATA =
-	    "sometestdata"			/* Data */
-	    "\0\0\0\0"				/* Key-ID (unused) */
-	    "\xc7\x58\x99\xdd\x99\x32\x0f\x71"	/* MAC */
-	    "\x2b\x7b\xfe\x4f\xa2\x32\xcf\x00"; /* Last byte is wrong! */
-	const int PKT_LEN = 12;
+#ifdef OPENSSL
+	const char KEY[] = "SHAKE128 unit test key";
+	const u_char PAYLOAD[] = "packettestdata1_";
+				/* last packet byte different */
+	const size_t PAYLOAD_LEN = sizeof(PAYLOAD) - 1;
+	const u_char EXPECTED_DIGEST[] =
+		"\x62\x5A\x8F\xE4\x66\xCB\xF3\xA6"
+		"\x73\x62\x68\x8D\x11\xB8\x42\xBB";
+	const size_t DIGEST_LEN = sizeof(EXPECTED_DIGEST) - 1;
+	struct key sk;
+	u_char PKT_DATA[  PAYLOAD_LEN + sizeof(sk.key_id)
+			+ DIGEST_LEN];
+	u_char *p;
+
+	sk.next = NULL;
+	sk.key_id = 0;
+	sk.key_len = sizeof(KEY) - 1;
+	memcpy(&sk.key_seq, KEY, min(sizeof(sk.key_seq), sk.key_len));
+	strlcpy(sk.typen, "SHAKE128", sizeof(sk.typen));
+	sk.typei = keytype_from_text(sk.typen, NULL);
+
+	p = PKT_DATA;
+	memcpy(p, PAYLOAD, PAYLOAD_LEN);	  p += PAYLOAD_LEN;
+	memcpy(p, &sk.key_id, sizeof(sk.key_id)); p += sizeof(sk.key_id);
+	memcpy(p, EXPECTED_DIGEST, DIGEST_LEN);	  p += DIGEST_LEN;
+	TEST_ASSERT_TRUE(sizeof(PKT_DATA) == p - PKT_DATA);
+
+	TEST_ASSERT_FALSE(auth_md5(PKT_DATA, PAYLOAD_LEN, DIGEST_LEN, &sk));
+#else
 
-	struct key md5;
-	md5.next = NULL;
-	md5.key_id = 0;
-	md5.key_len = 6;
-	memcpy(&md5.key_seq, "md5key", md5.key_len);
-	strlcpy(md5.typen, "MD5", sizeof(md5.typen));
-	md5.typei = keytype_from_text(md5.typen, NULL);
+	TEST_IGNORE_MESSAGE("OpenSSL not found, skipping...");
 
-	TEST_ASSERT_FALSE(auth_md5(PKT_DATA, PKT_LEN, MD5_LENGTH, &md5));
+#endif	/* OPENSSL */
 }
 
 
 void
 test_PacketSizeNotMultipleOfFourBytes(void)
 {
-	const char* PKT_DATA = "123456";
-	const int PKT_LEN = 6;
-	char actual[MD5_LENGTH];
-
-	struct key md5;
-	md5.next = NULL;
-	md5.key_id = 10;
-	md5.key_len = 6;
-	memcpy(&md5.key_seq, "md5seq", md5.key_len);
-	strlcpy(md5.typen, "MD5", sizeof(md5.typen));
-	md5.typei = keytype_from_text(md5.typen, NULL);
-
-	TEST_ASSERT_EQUAL(0, make_mac(PKT_DATA, PKT_LEN, MD5_LENGTH, &md5, actual));
+	/*
+	 * We use a copy of test_MakeSHAKE128Mac(), but modify
+	 * the packet length to 17.
+	 */
+#ifdef OPENSSL
+
+	const char KEY[] = "SHAKE128 unit test key";
+	const u_char PAYLOAD[] = "packettestdata_17";
+	const size_t PAYLOAD_LEN = sizeof(PAYLOAD) - 1;
+	const u_char EXPECTED_DIGEST[] =
+		"\x62\x5A\x8F\xE4\x66\xCB\xF3\xA6"
+		"\x73\x62\x68\x8D\x11\xB8\x42\xBB";
+	u_char actual[sizeof(EXPECTED_DIGEST) - 1];
+	struct key sk;
+
+	sk.next = NULL;
+	sk.key_id = 10;
+	sk.key_len = sizeof(KEY) - 1;
+	memcpy(&sk.key_seq, KEY, min(sizeof(sk.key_seq), sk.key_len));
+	strlcpy(sk.typen, "SHAKE128", sizeof(sk.typen));
+	sk.typei = keytype_from_text(sk.typen, NULL);
+
+	TEST_ASSERT_EQUAL(0,
+			  make_mac(PAYLOAD, PAYLOAD_LEN, &sk, actual,
+				   sizeof(actual)));
+#else
+
+	TEST_IGNORE_MESSAGE("OpenSSL not found, skipping...");
+
+#endif	/* OPENSSL */
 }
diff --git a/contrib/ntp/sntp/tests/fileHandlingTest.h.in b/contrib/ntp/sntp/tests/fileHandlingTest.h.in
index b93ed9e90293..86c9f2c7cd0e 100644
--- a/contrib/ntp/sntp/tests/fileHandlingTest.h.in
+++ b/contrib/ntp/sntp/tests/fileHandlingTest.h.in
@@ -1,3 +1,9 @@
+/*
+ * fileHandlingTest.h[.in]
+ *
+ * @configure_input@
+ */
+
 #ifndef FILE_HANDLING_TEST_H
 #define FILE_HANDLING_TEST_H
 
@@ -23,4 +29,4 @@ extern	int		GetFileSize(FILE *file);
 extern	bool		CompareFileContent(FILE* expected, FILE* actual);
 extern	void		ClearFile(const char * filename) ;
 
-#endif // FILE_HANDLING_TEST_H
+#endif	/* FILE_HANDLING_TEST_H */
diff --git a/contrib/ntp/sntp/tests/packetHandling.c b/contrib/ntp/sntp/tests/packetHandling.c
index 6787eeaa2fe9..cf52ccd60faa 100644
--- a/contrib/ntp/sntp/tests/packetHandling.c
+++ b/contrib/ntp/sntp/tests/packetHandling.c
@@ -72,26 +72,36 @@ test_GenerateUnauthenticatedPacket(void)
 void
 test_GenerateAuthenticatedPacket(void)
 {
-	static const int EXPECTED_PKTLEN = LEN_PKT_NOMAC + MAX_MD5_LEN;
-	
+#ifdef OPENSSL
+
+	const int EXPECTED_PKTLEN = LEN_PKT_NOMAC + MAX_SHAKE128_LEN;
+
 	struct key	testkey;
 	struct pkt	testpkt;
 	struct timeval	xmt;
 	l_fp		expected_xmt, actual_xmt;
-	char 		expected_mac[MAX_MD5_LEN];
-	
+	const char key[] = "123456789";
+	size_t		mac_sz;
+	const u_char 	expected_mac[] = {
+				0x46, 0x79, 0x81, 0x6b,
+				0x22, 0xe3, 0xa7, 0xaf,
+				0x1d, 0x63, 0x20, 0xfb,
+				0xc7, 0xd6, 0x87, 0x2c
+			};
+
 	testkey.next = NULL;
 	testkey.key_id = 30;
-	testkey.key_len = 9;
-	memcpy(testkey.key_seq, "123456789", testkey.key_len);
-	strlcpy(testkey.typen, "MD5", sizeof(testkey.typen));
+	strlcpy(testkey.key_seq, key, sizeof(testkey.key_seq));
+	testkey.key_len = strlen(testkey.key_seq);
+	strlcpy(testkey.typen, "SHAKE128", sizeof(testkey.typen));
 	testkey.typei = keytype_from_text(testkey.typen, NULL);
 
-	GETTIMEOFDAY(&xmt, NULL);
-	xmt.tv_sec += JAN_1970;
+	xmt.tv_sec = JAN_1970;
+	xmt.tv_usec = 0;
 
 	TEST_ASSERT_EQUAL(EXPECTED_PKTLEN,
-			  generate_pkt(&testpkt, &xmt, testkey.key_id, &testkey));
+			  generate_pkt(&testpkt, &xmt, testkey.key_id,
+			  &testkey));
 
 	TEST_ASSERT_EQUAL(LEAP_NOTINSYNC, PKT_LEAP(testpkt.li_vn_mode));
 	TEST_ASSERT_EQUAL(NTP_VERSION, PKT_VERSION(testpkt.li_vn_mode));
@@ -105,10 +115,20 @@ test_GenerateAuthenticatedPacket(void)
 	TEST_ASSERT_TRUE(LfpEquality(expected_xmt, actual_xmt));
 
 	TEST_ASSERT_EQUAL(testkey.key_id, ntohl(testpkt.exten[0]));
-	
-	TEST_ASSERT_EQUAL(MAX_MD5_LEN - 4, /* Remove the key_id, only keep the mac. */
-			  make_mac(&testpkt, LEN_PKT_NOMAC, MAX_MD5_LEN-4, &testkey, expected_mac));
-	TEST_ASSERT_EQUAL_MEMORY(expected_mac, (char*)&testpkt.exten[1], MAX_MD5_LEN -4);
+
+	TEST_ASSERT_EQUAL(sizeof(expected_mac), SHAKE128_LENGTH);
+ 	mac_sz = make_mac(&testpkt, LEN_PKT_NOMAC, &testkey,
+			  &testpkt.exten[1], MAX_MDG_LEN);
+	TEST_ASSERT_EQUAL(mac_sz, SHAKE128_LENGTH);
+
+	TEST_ASSERT_EQUAL_MEMORY(expected_mac, (void *)&testpkt.exten[1],
+				 SHAKE128_LENGTH);
+
+#else	/* !OPENSSL follows */
+
+	TEST_IGNORE_MESSAGE("OpenSSL not found, skipping...");
+
+#endif
 }
 
 
@@ -169,7 +189,7 @@ test_OffsetCalculationNegativeOffset(void)
 	rpkt.precision = -1;
 	rpkt.rootdelay = HTONS_FP(DTOUFP(0.5));
 	rpkt.rootdisp = HTONS_FP(DTOUFP(0.5));
-	
+
 	/* Synch Distance is (0.5+0.5)/2.0, or 0.5 */
 	get_systime(&reftime);
 	HTONL_FP(&reftime, &rpkt.reftime);
